using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Winnovative.WnvRtfToPdf;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            string defaultRtfFilePath = System.IO.Path.Combine(Server.MapPath("~"), "convert_sample.rtf");
            textBoxRtfFilePath.Text = defaultRtfFilePath;
        }

        lblConvertMessage.Visible = false;
    }

    protected void btnConvert_Click(object sender, EventArgs e)
    {
        if (!Page.IsValid)
            return;

        string rtfFileToConvert = textBoxRtfFilePath.Text.Trim();

        // Create the PDF converter. Optionally you can specify the virtual RTF viewer 
        // width as a parameter. 800 pixels is default.
        PdfConverter pdfConverter = new PdfConverter();

        // set the RTF viewer width to the specified value before conversion
        pdfConverter.PageWidth = int.Parse(textBoxViewerWidth.Text.Trim());

        // set the license key - required
        pdfConverter.LicenseKey = "Yuz97frt/e354/3t/vzj/P/j9PT09A==";

        // set the converter options - optional
        pdfConverter.PdfDocumentOptions.PdfPageSize = PdfPageSize.A4;
        pdfConverter.PdfDocumentOptions.PdfCompressionLevel = PdfCompressionLevel.Normal;
        pdfConverter.PdfDocumentOptions.PdfPageOrientation = PDFPageOrientation.Portrait;
        pdfConverter.PdfDocumentOptions.ShowHeader = false;
        pdfConverter.PdfDocumentOptions.ShowFooter = false;
        // set the embedded fonts option - optional, by default is false
        pdfConverter.PdfDocumentOptions.EmbedFonts = false;

        // Performs the conversion and get the pdf document bytes that you can further 
        // save to a file or send as a browser response
        byte[] pdfBytes = pdfConverter.GetPdfBytesFromRtfFile(rtfFileToConvert);

        // send the PDF document as a response to the browser for download
        System.Web.HttpResponse response = System.Web.HttpContext.Current.Response;
        response.Clear();
        response.AddHeader("Content-Type", "binary/octet-stream");
        response.AddHeader("Content-Disposition",
            "attachment; filename=ConversionResult.pdf; size=" + pdfBytes.Length.ToString());
        response.Flush();
        response.BinaryWrite(pdfBytes);
        response.Flush();
        response.End();
    }
    protected void cvRtfViewerWidth_ServerValidate(object source, ServerValidateEventArgs args)
    {
        args.IsValid = true;

        int rtfViewerWidth = 800; // default value
        try
        {
            rtfViewerWidth = int.Parse(textBoxViewerWidth.Text.Trim());
        }
        catch
        {
            args.IsValid = false;
            return;
        }
        if (rtfViewerWidth < 100)
        {
            args.IsValid = false;
            return;
        }
    }
}
